//+------------------------------------------------------------------+
//|                                           FXA0 - Ladderv0.01.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""


double Lots = 0.1;

extern int TJMA=30;
extern int TJMA2=3;
extern int time=60;
extern int time0=240;

extern double level1=0.1, level2=0.4, level3=0.2;
extern double SLlevel1=0, SLlevel2=70, SLlevel3=40;
extern double TPlevel=10, TPleve2=10, TPleve3=12;

extern double ATRvalue=0.0011, ATR_timeframe=1, ATR_Period=4;
extern double ATRvalue2=0.0005, ATR_timeframe2=5, ATR_Period2=1;
extern double ATRvalue3=0.003, ATR_timeframe3=15, ATR_Period3=2;
extern double ATRvalue4=0.005, ATR_timeframe4=30, ATR_Period4=3;


extern double dist=15;



int ticket, OpenOrders=0, cnt=0, slippage=5, lastType=0, notrade=0, LastType=0;
double sl=0, tp=0, BuyPrice=0, SellPrice=0, Profit=0, LastPrice=0;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()   {   return(0); }
int deinit()   {   return(0);  }

//+------------------------------------------------------------------+
//| value added functions                                            |
//+------------------------------------------------------------------+
void CloseAllOrders()
{   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	   if (OrderSymbol()==Symbol())// && OrderMagicNumber()==MagicNumber) 
      {         if (OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow); }
         if (OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow); }
         return(0);
      }    }   }


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
  {

{
  	int QPoints=0;

if (iCustom(Symbol(),time,"Turbo_JMA",TJMA,MODE_MAIN,1)>iCustom(Symbol(),time,"Turbo_JMA",TJMA,MODE_MAIN,2)
&& iCustom(Symbol(),time0,"Turbo_JMA",TJMA2,MODE_MAIN,1)>iCustom(Symbol(),time0,"Turbo_JMA",TJMA2,MODE_MAIN,2)

)	  { QPoints=1;}

if (iCustom(Symbol(),time,"Turbo_JMA",TJMA,MODE_MAIN,1)<iCustom(Symbol(),time,"Turbo_JMA",TJMA,MODE_MAIN,2)
&& iCustom(Symbol(),time0,"Turbo_JMA",TJMA2,MODE_MAIN,1)<iCustom(Symbol(),time0,"Turbo_JMA",TJMA2,MODE_MAIN,2)

)	  { QPoints=-1;}
}  


  
   //finds current profit on last opened order, last type of order and the total number of open orders
   lastType=0;OpenOrders=0;Profit=0;  LastPrice=0; 

	for(cnt=0;cnt<OrdersTotal();cnt++)
	{OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	
			LastPrice=OrderOpenPrice();
if (OrderType()==OP_BUY) 			{Profit=OrderProfit();        lastType=1;}
if (OrderType()==OP_SELL) 			{Profit=OrderProfit();        lastType=2;}
  		   OpenOrders++; 
   }
   
   //close orders if market changes in opposite direction
   if(lastType==1 && QPoints<0) { CloseAllOrders(); }
   if(lastType==2 && QPoints>0) { CloseAllOrders(); }

if (ATRvalue>=iATR(NULL,ATR_timeframe,ATR_Period,0))  notrade=0; else notrade=1;
if (ATRvalue2>=iATR(NULL,ATR_timeframe2,ATR_Period2,0))  notrade=0; else notrade=1;
if (ATRvalue3>=iATR(NULL,ATR_timeframe3,ATR_Period3,0))  notrade=0; else notrade=1;
if (ATRvalue4>=iATR(NULL,ATR_timeframe4,ATR_Period4,0))  notrade=0; else notrade=1;



//if(0.005>=iATR(NULL,60,1,0))  notrade=0; else notrade=1;

if(notrade==0)
{
{
   if(OpenOrders==0)
   {
      //marketQualityValue=marketQuality();
      if(QPoints==1)
      {
ticket=OrderSend(Symbol(),OP_BUY,level1,Ask,slippage,SLlevel1//Bid-30*Point
                                                   ,Ask+TPlevel*Point,"L",0,0,Blue);
         return(0);
      }
      if(QPoints==-1)
      {
ticket=OrderSend(Symbol(),OP_SELL,level1,Bid,slippage,SLlevel1//Ask+30*Point
                                                    ,Bid-TPlevel*Point,"L",0,0,Red);
         return(0);
      }
      if(QPoints==0)
      {
        Print("No market to open"); 
      }
   }
   
   ticket=0;
   if(OpenOrders==1 && lastType==1 && QPoints==1 && ((LastPrice-Ask)>=dist*Point))
{ticket=OrderSend(Symbol(),OP_BUY,level2,Ask,slippage,Bid-SLlevel2*Point,Ask+TPleve2*Point,"L",0,0,Blue);
   }
   
      if(OpenOrders==2 && lastType==1 && QPoints==1 && ((LastPrice-Ask)>=dist*Point))
{ticket=OrderSend(Symbol(),OP_BUY,level3,Ask,slippage,Bid-SLlevel3*Point,Ask+TPleve3*Point,"L",0,0,Blue);
   }
   
   if(OpenOrders==1 && lastType==2 && QPoints==-1 && ((Bid-LastPrice)>=dist*Point))
{ticket=OrderSend(Symbol(),OP_SELL,level2,Bid,slippage,Ask+SLlevel2*Point,Bid-TPleve2*Point,"L",0,0,Red);
   }
   
      if(OpenOrders==2 && lastType==2 && QPoints==-1 && ((Bid-LastPrice)>=dist*Point))
{ticket=OrderSend(Symbol(),OP_SELL,level3,Bid,slippage,Ask+SLlevel3*Point,Bid-TPleve3*Point,"L",0,0,Red);
   }
//----
  }   }
   return(0);
  }
//+------------------------------------------------------------------+


